﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace _92163
{
    public partial class Form1 : Form
    {
        DataSet ds;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Get the Sample Data required for Appointments and Owners data binding
            ds = this.GetSampleData();
            ultraGrid1.DataSource = ds;

            // Hide the Unassigned Owner
            this.ultraCalendarInfo1.Owners.UnassignedOwner.Visible = false;

            // Bind ultraCalendarInfo to Appointments Data Table
            this.ultraCalendarInfo1.DataBindingsForAppointments.DataSource = ds.Tables["Appointments"];

            // Bind ultraCalendarInfo to Owners Data Table
            this.ultraCalendarInfo1.DataBindingsForOwners.DataSource = ds.Tables["Owners"];

            // Set Appointments data binding properties to UltraCalendarInfo
            this.ultraCalendarInfo1.DataBindingsForAppointments.StartDateTimeMember = "StartTime";

            this.ultraCalendarInfo1.DataBindingsForAppointments.EndDateTimeMember = "EndTime";

            this.ultraCalendarInfo1.DataBindingsForAppointments.SubjectMember = "Subject";
            this.ultraCalendarInfo1.DataBindingsForAppointments.OwnerKeyMember = "OwnerKey";
            this.ultraCalendarInfo1.DataBindingsForAppointments.AllPropertiesMember = "AllProperties";

            // Set Owners data binding properties to UltraCalendarInfo
            this.ultraCalendarInfo1.DataBindingsForOwners.KeyMember = "OwnerKey";
            this.ultraCalendarInfo1.DataBindingsForOwners.NameMember = "Name";

            // Assign CalendarInfo component to TimelineView control

            ultraDayView1.CalendarInfo = this.ultraCalendarInfo1;

            // Set UltraCalendarLook ViewStyle
            this.ultraCalendarLook1.ViewStyle = Infragistics.Win.UltraWinSchedule.ViewStyle.Office2007;

            // Assign CalendarLook component to TimeLineView control
            this.ultraDayView1.CalendarLook = this.ultraCalendarLook1;
        }

        private DataSet GetSampleData()
        {
            DataSet theDataSet = new DataSet();
            string path = "..\\..\\Data";
            if (!Directory.Exists(path))
                Directory.CreateDirectory(path);
            if (File.Exists(string.Format("{0}\\XmlSchema", path)) && File.Exists(string.Format("{0}\\XmlData", path)))
            {
                theDataSet.ReadXmlSchema(string.Format("{0}\\XmlSchema", path));
                theDataSet.ReadXml(string.Format("{0}\\XmlData", path));
                return theDataSet;
            }
            // Create Owners DataTable
            DataTable theOwners = theDataSet.Tables.Add("Owners");
            theOwners.Columns.Add("OwnerID", typeof(int));
            theOwners.Columns.Add("Name", typeof(string));
            theOwners.Columns.Add("OwnerKey", typeof(string));

            // Add Owners Sample Data
            theOwners.Rows.Add(new object[] { "1", "Maria Charlie", "Charlie" });
            theOwners.Rows.Add(new object[] { "2", "John Jamie", "Jamie" });
            theOwners.Rows.Add(new object[] { "3", "Matthew Lukas", "Lukas" });
            theOwners.Rows.Add(new object[] { "4", "Leah Lopez", "Lopez" });
            
            
            // Create Appointments DataTable
            DataTable theAppointments = theDataSet.Tables.Add("Appointments");
            theAppointments.Columns.Add("AppointmentID", typeof(int));
            theAppointments.Columns.Add("StartTime", typeof(DateTime));
            theAppointments.Columns.Add("EndTime", typeof(DateTime));
            theAppointments.Columns.Add("Subject", typeof(string));
            theAppointments.Columns.Add("OwnerKey", typeof(string));
            theAppointments.Columns.Add("AllProperties", typeof(object));

            // Add Appointments Sample Data
            theAppointments.Rows.Add(new object[] { "1", DateTime.Now, DateTime.Now.AddMinutes(120), "Sprint Review", "Charlie" });
            theAppointments.Rows.Add(new object[] { "1", DateTime.Now.AddMinutes(90), DateTime.Now.AddMinutes(260), "Scrum Meet", "Jamie" });
            theAppointments.Rows.Add(new object[] { "1", DateTime.Now.AddMinutes(120), DateTime.Now.AddMinutes(300), "Status Meeting", "Lukas" });
            theAppointments.Rows.Add(new object[] { "1", DateTime.Now.AddMinutes(180), DateTime.Now.AddMinutes(380), "Feature Review", "Lopez" });


            theDataSet.Relations.Add(theOwners.Columns["OwnerKey"], theAppointments.Columns["OwnerKey"]);

            return theDataSet;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            string path = "..\\..\\Data";
            if (!Directory.Exists(path))
                Directory.CreateDirectory(path);
            ds.WriteXmlSchema(string.Format("{0}\\XmlSchema", path));
            ds.WriteXml(string.Format("{0}\\XmlData", path));
        }
    }
}
